package com.igaworks.adbrixrm_flutter_example;

import android.util.Log;

import androidx.annotation.NonNull;

import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.messaging.FirebaseMessaging;
import com.igaworks.adbrixrm_flutter.AdbrixrmFlutterPlugin;

import io.flutter.app.FlutterApplication;

public class BaseApplication extends FlutterApplication {
    public static final String TAG = "flutter";
    @Override
    public void onCreate() {
        super.onCreate();
//        refreshFirebaseMessagingToken();
        AdbrixrmFlutterPlugin.sdkInit(BaseApplication.this,"YOUR_APPKEY", "YOUR_SECRETKEY");
        AdbrixrmFlutterPlugin.setDeeplinkListener();
    }

    private void refreshFirebaseMessagingToken(){
        FirebaseMessaging.getInstance().getToken()
            .addOnCompleteListener(new OnCompleteListener<String>() {
                @Override
                public void onComplete(@NonNull Task<String> task) {
                    if (!task.isSuccessful()) {
                        Log.w(TAG, "Fetching FCM registration token failed", task.getException());
                        return;
                    }

                    // Get new FCM registration token
                    String token = task.getResult();
                    AdbrixrmFlutterPlugin.setRegistrationId(token);
                }
            });
    }
}
