import 'dart:io';

import 'package:adbrixrm_flutter/adbrixrm.dart';
import 'package:flutter/material.dart';

class v2ApiView extends StatefulWidget {
  @override
  _v2ApiViewState createState() => _v2ApiViewState();
}

class _v2ApiViewState extends State<v2ApiView> {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: Center(
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: <Widget>[
            Text('V2 API'),
            Row(
              mainAxisAlignment: MainAxisAlignment.spaceEvenly,
              children: <Widget>[
                ElevatedButton(
                    child: Text('flushAllEvents'),
                    onPressed: flushAllEvents,
                    style: ButtonStyle(
                      padding: MaterialStateProperty.all<EdgeInsets>(
                          EdgeInsets.all(8)),
                    )),
                ElevatedButton(
                    child: Text('delete'),
                    onPressed: deleteUserData,
                    style: ButtonStyle(
                      padding: MaterialStateProperty.all<EdgeInsets>(
                          EdgeInsets.all(8)),
                    )),
                ElevatedButton(
                    child: Text('restart'),
                    onPressed: restart,
                    style: ButtonStyle(
                      padding: MaterialStateProperty.all<EdgeInsets>(
                          EdgeInsets.all(8)),
                    )),
              ],
            ),
            Row(
              mainAxisAlignment: MainAxisAlignment.spaceEvenly,
              children: <Widget>[
                ElevatedButton(
                    child: Text('getAllIAM'),
                    onPressed: getAllInAppMessage,
                    style: ButtonStyle(
                      padding: MaterialStateProperty.all<EdgeInsets>(
                          EdgeInsets.all(8)),
                    )),
                ElevatedButton(
                    child: Text('fetchIAM'),
                    onPressed: fetchInAppMessage,
                    style: ButtonStyle(
                      padding: MaterialStateProperty.all<EdgeInsets>(
                          EdgeInsets.all(8)),
                    )),
                ElevatedButton(
                    child: Text('openIAM'),
                    onPressed: openIAM,
                    style: ButtonStyle(
                      padding: MaterialStateProperty.all<EdgeInsets>(
                          EdgeInsets.all(8)),
                    ))
              ],
            ),
            // Row(
            //   mainAxisAlignment: MainAxisAlignment.spaceEvenly,
            //   children: <Widget>[
            //     ElevatedButton(
            //         child: Text('getAllAH'),
            //         onPressed: getAllActionHistory,
            //         style: ButtonStyle(
            //           padding: MaterialStateProperty.all<EdgeInsets>(
            //               EdgeInsets.all(8)),
            //         )),
            //     ElevatedButton(
            //         child: Text('fetchAH'),
            //         onPressed: fetchActionHistory,
            //         style: ButtonStyle(
            //           padding: MaterialStateProperty.all<EdgeInsets>(
            //               EdgeInsets.all(8)),
            //         )),
            //     ElevatedButton(
            //         child: Text('deleteAllAH'),
            //         onPressed: deleteAllActionHistory,
            //         style: ButtonStyle(
            //           padding: MaterialStateProperty.all<EdgeInsets>(
            //               EdgeInsets.all(8)),
            //         ))
            //   ],
            // ),
            // Row(
            //   mainAxisAlignment: MainAxisAlignment.spaceEvenly,
            //   children: <Widget>[
            //     ElevatedButton(
            //         child: Text('registerLocalPush'),
            //         onPressed: registerLocalPush,
            //         style: ButtonStyle(
            //           padding: MaterialStateProperty.all<EdgeInsets>(
            //               EdgeInsets.all(8)),
            //         )),
            //     ElevatedButton(
            //         child: Text('getPushList'),
            //         onPressed: getPushEventList,
            //         style: ButtonStyle(
            //           padding: MaterialStateProperty.all<EdgeInsets>(
            //               EdgeInsets.all(8)),
            //         )),
            //     ElevatedButton(
            //         child: Text('cancelPush'),
            //         onPressed: cancelClientPushEvent,
            //         style: ButtonStyle(
            //           padding: MaterialStateProperty.all<EdgeInsets>(
            //               EdgeInsets.all(8)),
            //         ))
            //   ],
            // ),
            // Row(
            //   mainAxisAlignment: MainAxisAlignment.spaceEvenly,
            //   children: <Widget>[
            //     ElevatedButton(
            //         child: Text('BigTextLocalPush'),
            //         onPressed: bigTextLocalPush,
            //         style: ButtonStyle(
            //           padding: MaterialStateProperty.all<EdgeInsets>(
            //               EdgeInsets.all(8)),
            //         )),
            //     ElevatedButton(
            //         child: Text('BigPictureLocalPush'),
            //         onPressed: bigPictureLocalPush,
            //         style: ButtonStyle(
            //           padding: MaterialStateProperty.all<EdgeInsets>(
            //               EdgeInsets.all(8)),
            //         ))
            //   ],
            // ),
            // Row(
            //   mainAxisAlignment: MainAxisAlignment.spaceEvenly,
            //   children: <Widget>[
            //     ElevatedButton(
            //       child: Text('getSdkVersion'),
            //       onPressed: getSdkVersion,
            //       style: ButtonStyle(
            //         padding: MaterialStateProperty.all<EdgeInsets>(
            //             EdgeInsets.all(4)),
            //       )),
            //     ElevatedButton(
            //         child: Text('setPushIconStyle'),
            //         onPressed: setPushIconStyle,
            //         style: ButtonStyle(
            //           padding: MaterialStateProperty.all<EdgeInsets>(
            //               EdgeInsets.all(4)),
            //         )),
            //     ElevatedButton(
            //         child: Text('setNotificationOption'),
            //         onPressed: setNotificationOption,
            //         style: ButtonStyle(
            //           padding: MaterialStateProperty.all<EdgeInsets>(
            //               EdgeInsets.all(4)),
            //         ))
            //   ],
            // ),
            Row(
              mainAxisAlignment: MainAxisAlignment.spaceEvenly,
              children: <Widget>[
                ElevatedButton(
                    child: Text('setInAppMessageFetchMode'),
                    onPressed: setInAppMessageFetchMode,
                    style: ButtonStyle(
                      padding: MaterialStateProperty.all<EdgeInsets>(
                          EdgeInsets.all(8)),
                    )),
                ElevatedButton(
                    child: Text('setInAppMessageToken'),
                    onPressed: setInAppMessageToken,
                    style: ButtonStyle(
                      padding: MaterialStateProperty.all<EdgeInsets>(
                          EdgeInsets.all(8)),
                    ))
              ],
            ),
          ],
        ),
      ),
    );
  }

  Future<void> deleteUserData() async {
    var result = AdBrixRm.deleteUserDataAndStopSDK(userId: "userID_Flutter");

    result.then((isSuccess) {
      if (isSuccess == true) {
        debugPrint("abxrm :: deleteUserData Success!!");
      } else {
        debugPrint("abxrm :: deleteUserData Fail!!");
      }
    }).catchError((error) {
      debugPrint("abxrm :: deleteUserData error " + error.toString());
    });
  }

  Future<void> flushAllEvents() async {
    var result = AdBrixRm.flushAllEvents();

    result.then((isSuccess) {
      if (isSuccess == true) {
        debugPrint("abxrm :: flushAllEvents Success!!");
      } else {
        debugPrint("abxrm :: flushAllEvents Fail!!");
      }
    }).catchError((error) {
      debugPrint("abxrm :: flushAllEvents error " + error.toString());
    });
  }

  Future<void> restart() async {
    var result = AdBrixRm.restartSDK(userId: "userID_Flutter");
    result.then((isSuccess) {
      if (isSuccess == true) {
        debugPrint("abxrm :: restartSDK Success!!");
      } else {
        debugPrint("abxrm :: restartSDK Fail!!");
      }
    }).catchError((error) {
      debugPrint("abxrm :: restartSDK error " + error.toString());
    });
  }

  Future<void> getAllInAppMessage() async {
    var result = AdBrixRm.getAllInAppMessage();

    result.then((value) {
      debugPrint("abxrm :: getAllInAppMessage data " + value!);
    }).catchError((error) {
      debugPrint("abxrm :: getAllInAppMessage error " + error.toString());
    });
  }

  Future<void> fetchInAppMessage() async {
    var result = AdBrixRm.fetchInAppMessage();

    result.then((value) {
      debugPrint("abxrm :: fetchInAppMessage isSuccess " + value.toString());
    }).catchError((error) {
      debugPrint("abxrm :: fetchInAppMessage " + error.toString());
    });
  }

  Future<void> openIAM() async {
    var result =
        AdBrixRm.openInAppMessage(campaignId: "Um1VLCMNtEGuRW6qcey4pA");

    result.then((value) {
      debugPrint("abxrm :: getAndOpenIAM isSuccess " + value.toString());
    }).catchError((error) {
      debugPrint("abxrm :: getAndOpenIAM " + error.toString());
    });
  }

  // Future<void> fetchActionHistory() async {
  //   var result = AdBrixRm.fetchActionHistoryByUserId(
  //       token: null,
  //       actionType: ["PUSH_ANDROID", "PUSH_IOS", "KAKAOTALK", "TEXT_MESSAGE"]);

  //   result.then((value) {
  //     debugPrint("abxrm :: fetchActionHistory isSuccess " + value!);
  //   }).catchError((error) {
  //     debugPrint("abxrm :: fetchActionHistory " + error.toString());
  //   });
  // }

  // Future<void> getAllActionHistory() async {
  //   var result = AdBrixRm.getAllActionHistory(
  //       actionType: ["PUSH_ANDROID", "PUSH_IOS", "KAKAOTALK", "TEXT_MESSAGE"]);

  //   result.then((value) {
  //     debugPrint("abxrm :: fetchActionHistory isSuccess " + value!);
  //   }).catchError((error) {
  //     debugPrint("abxrm :: fetchActionHistory " + error.toString());
  //   });
  // }

  // Future<void> deleteAllActionHistory() async {
  //   var result = AdBrixRm.deleteAllActionHistoryByUserId(token: null);

  //   result.then((value) {
  //     debugPrint("abxrm :: fetchActionHistory isSuccess " + value.toString());
  //   }).catchError((error) {
  //     debugPrint("abxrm :: fetchActionHistory " + error.toString());
  //   });
  // }

  // Future<void> registerLocalPush() async {
  //   if (Platform.isIOS) {
  //     var result = AdBrixRm.registeriOSLocalPushNotification(
  //         new DfniOSLocalPushParameter("1234", 5, "title", "subtitle", "body",
  //             null, null, 2, "https://picsum.photos/100/100"));

  //     result?.then((value) {
  //       debugPrint("abxrm :: registerLocalPush isSuccess :: " + value.toString());
  //     }).catchError((error) {
  //       debugPrint("abxrm :: registerLocalPush " + error.toString());
  //     });
  //   }
  // }

  // Future<void> getPushEventList() async {
  //   var result = AdBrixRm.getPushEventList();

  //   result.then((value) {
  //     debugPrint("abxrm :: getPushEventList isSuccess, data =" + value!);
  //   }).catchError((error) {
  //     debugPrint("abxrm :: registerLocalPush " + error.toString());
  //   });
  // }

  // Future<void> cancelClientPushEvent() async {
  //   AdBrixRm.cancelLocalPushNotification(["1234"]);
  // }
  // void bigTextLocalPush() {
  //   var properties = BigTextPushProperties(0, 123, "title", "contentText", "summaryText", "bigContentTitle", "bigText", "deepLinkUri");
  //   AdBrixRm.setBigTextClientPushEvent(properties, true);
  // }
  // void bigPictureLocalPush(){
  //   var properties = BigPicturePushProperties(0, 124, -1, "title", "contentText", "summaryText", "bigContentTitle", "http://tenasia.hankyung.com/webwp_kr/wp-content/uploads/2017/06/2017061317014472960.jpg", "deepLinkUri");
  //   AdBrixRm.setBigPictureClientPushEvent(properties, true);
  // }
  // void getSdkVersion(){
  //   var version = AdBrixRm.getSdkVersion();
  //   version.then((value) =>
  //       debugPrint("abxrm :: getSdkVersion: " + value!)
  //   );
  // }
  void setInAppMessageFetchMode(){
    AdBrixRm.setInAppMessageFetchMode(dfnInAppMessageFetchMode: DfnInAppMessageFetchMode.USER_ID);
  }
  void setInAppMessageToken(){
    AdBrixRm.setInAppMessageToken(token: "token");
  }

  // void setPushIconStyle(){
  //   AdBrixRm.setPushIconStyle("smallIconName", "largeIconName");
  // }
  // void setNotificationOption(){
  //   AdBrixRm.setNotificationOption(NotificationCompat.PRIORITY_MAX, NotificationCompat.VISIBILITY_PUBLIC);
  // }
}
